<ion-content>
    <ion-toolbar>
        <ion-buttons slot="start">
            <ion-menu-button></ion-menu-button>
        </ion-buttons>
        <ion-item>
            <ion-label>{{ 'Home' | translate}} >> {{ 'Demands' | translate }}</ion-label>
        </ion-item>
    </ion-toolbar>
    <ion-refresher slot="fixed" (ionRefresh)="onRefresh($event)">
        <ion-refresher-content pullingIcon="arrow-down" refreshingSpinner="circles">
        </ion-refresher-content>
    </ion-refresher>
    <div *ngIf="!this.cache?.isLoading">
        <ion-list *ngFor="let demandLog of this.cache?.objects">
            <ion-card (click)="this.cache.getObject(demandLog.id)" >
                <ion-item>
                    <ion-label>
                        <ion-icon name="wallet"></ion-icon>
                        {{ 'Demand' | translate}} : ₹ {{demandLog?.demand?.amount}}</ion-label>
                        <ion-icon end *ngIf="demandLog.unRead" name="mail-unread"></ion-icon>
                </ion-item>
                <ion-card-content>
                    <ion-grid>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="information"></ion-icon>
                                {{demandLog?.demand?.name}}</ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label>
                                <ion-icon name="newspaper"></ion-icon>
                                {{demandLog?.demand?.description}}</ion-label>
                        </ion-row>
                        <ion-row>
                            <ion-label
                                *ngIf="isExpired(demandLog.demand.dueDate) && demandLog.paymentStatus == 'Due'; else elseBlock"
                                style="color: red;">
                                <ion-icon name="time"></ion-icon>
                                {{getLocalTime(demandLog.demand.dueDate) | date:'medium'}}
                            </ion-label>
                            <ng-template #elseBlock>
                                <ion-row>
                                    <ion-label>
                                        <ion-icon name="time"></ion-icon>
                                        {{getLocalTime(demandLog.demand.dueDate) | date:'medium'}}
                                    </ion-label>
                                </ion-row>
                            </ng-template>
                        </ion-row>
                        <ion-row>
                            <ion-chip color="success" *ngIf="demandLog.paymentStatus == 'Paid'; else elseBlock2">
                                <ion-icon name="checkmark"></ion-icon>
                                <ion-label>{{ 'Paid' | translate }}</ion-label>
                            </ion-chip>
                            <ng-template #elseBlock2>
                                <ion-button color="primary" (click)="pay(demandLog)">
                                    {{ 'Pay' | translate }}
                                </ion-button>
                            </ng-template>
                        </ion-row>
                        <ion-row *ngIf="demandLog?._cache_pending_operation == 'add'" style="color: orangered;">
                            <ion-icon name="alert"> </ion-icon>
                            {{ 'ADDED: not synced to server' | translate }}
                        </ion-row>
                        <ion-row *ngIf="demandLog?._cache_pending_operation == 'update'" style="color: goldenrod;">
                            <ion-icon name="alert">r</ion-icon>
                            {{ 'UPDATED: not synced to server' | translate }}
                        </ion-row>
                        <ion-row *ngIf="demandLog?._cache_pending_operation == 'delete'" style="color: red;">
                            <ion-icon name="alert">r</ion-icon>
                            {{ 'DELETED: not synced to server' | translate }}
                        </ion-row>
                    </ion-grid>
                </ion-card-content>
            </ion-card>
        </ion-list>
        <ion-card *ngIf="!this.cache?.isLoading && this.cache?.objects.length==0">
            <ion-item>
                <ion-label>{{ 'No records found!!!' | translate }}</ion-label>
            </ion-item>
        </ion-card>


        <ion-infinite-scroll threshold="100px" (ionInfinite)="loadNext($event)">
            <ion-infinite-scroll-content loadingSpinner="bubbles" loadingText="Loading ...">
            </ion-infinite-scroll-content>
        </ion-infinite-scroll>
    </div>

    <ion-card *ngIf="this.cache?.isLoading && this.cache?.objects.length==0">
        <ion-card-header>
            <ion-card-title>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-card-title>
            <ion-card-subtitle>
                <ion-skeleton-text animated></ion-skeleton-text>
            </ion-card-subtitle>
        </ion-card-header>

        <ion-card-content>
            <ion-item>
                <ion-label>
                    <ion-skeleton-text animated></ion-skeleton-text>
                </ion-label>
            </ion-item>
            <div>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
                <ion-skeleton-text animated></ion-skeleton-text>
            </div>
        </ion-card-content>
    </ion-card>
</ion-content>